Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -3989,17 +4298,16 @@ static Image *ReadMNGImage(const ImageIn
               int
                 repeat=0;
 
-
               if (length)
                 repeat=p[0];
-              if (repeat == 3)
+              if (repeat == 3 && length > 8)
                 {
                   final_delay=(png_uint_32) mng_get_long(&p[2]);
                   mng_iterations=(png_uint_32) mng_get_long(&p[6]);
                   if (mng_iterations == PNG_MAX_UINT)
                     mng_iterations=0;
                   image->iterations=mng_iterations;
-                  term_chunk_found=True;
+                  term_chunk_found=MagickTrue;
                 }
               if (logging)
                 {
@@ -4017,13 +4325,29 @@ static Image *ReadMNGImage(const ImageIn
           if (!memcmp(type,mng_DEFI,4))
             {
               if (mng_type == 3)
-                (void) ThrowException2(&image->exception,CoderError,
-                                       "DEFI chunk found in MNG-VLC datastream",
-                                       (char *) NULL);
-              object_id=(p[0] << 8) | p[1];
+                {
+                  if (logging)
+                    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                          "DEFI chunk found in MNG-VLC"
+                                          " datastream");
+                  MagickFreeMemory(chunk);
+                  continue;
+                }
+              if (length < 2)
+                {
+                  if (logging)
+                    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                          "  DEFI chunk must be at least"
+                                          " 2 bytes long");
+                  MagickFreeMemory(chunk);
+                  MngInfoFreeStruct(mng_info,&have_mng_structure);
+                  ThrowReaderException(CorruptImageError,CorruptImage,image);
+                }
+              object_id=((magick_uint32_t) p[0] << 8) | (magick_uint32_t) p[1];
               if (mng_type == 2 && object_id != 0)
                 (void) ThrowException2(&image->exception,CoderError,
-                                       "Nonzero object_id in MNG-LC datastream",
+                                       "Nonzero object_id in MNG-LC"
+                                       " datastream",
                                        (char *) NULL);
               if (object_id > MNG_MAX_OBJECTS)
                 {
@@ -4031,20 +4355,22 @@ static Image *ReadMNGImage(const ImageIn
                     Instead of issuing a warning we should allocate a larger
                     MngInfo structure and continue.
                   */
-                  (void) ThrowException2(&image->exception,CoderError,
-                                         "object id too large",(char *) NULL);
+                  if (logging)
+                    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                          "object id too large");
                   object_id=MNG_MAX_OBJECTS;
                 }
               if (mng_info->exists[object_id])
                 if (mng_info->frozen[object_id])
                   {
+                    if (logging)
+                      (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                            "DEFI cannot redefine a frozen"
+                                           " MNG object");
                     MagickFreeMemory(chunk);
-                    (void) ThrowException2(&image->exception,CoderError,
-                                           "DEFI cannot redefine a frozen MNG object",
-                                           (char *) NULL);
                     continue;
                   }
-              mng_info->exists[object_id]=True;
+              mng_info->exists[object_id]=MagickTrue;
               if (length > 2)
                 mng_info->invisible[object_id]=p[2];
               /*
@@ -4052,10 +4378,8 @@ static Image *ReadMNGImage(const ImageIn
               */
               if (length > 11)
                 {
-                  mng_info->x_off[object_id]=(long) ((p[4] << 24) | (p[5] << 16) |
-                                                     (p[6] << 8) | p[7]);
-                  mng_info->y_off[object_id]=(long) ((p[8] << 24) | (p[9] << 16) |
-                                                     (p[10] << 8) | p[11]);
+                  mng_info->x_off[object_id]= mng_get_long(&p[4]);
+                  mng_info->y_off[object_id]= mng_get_long(&p[8]);
                   if (logging)
                     {
                       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
@@ -4070,23 +4394,26 @@ static Image *ReadMNGImage(const ImageIn
                 Extract object clipping info.
               */
               if (length > 27)
-                mng_info->object_clip[object_id]=mng_read_box(mng_info->frame,0,
-                                                              &p[12]);
+                mng_info->object_clip[object_id]
+                   =mng_read_box( mng_info->frame,0,&p[12]);
               MagickFreeMemory(chunk);
               continue;
             }
           if (!memcmp(type,mng_bKGD,4))
             {
-              mng_info->have_global_bkgd=False;
+              mng_info->have_global_bkgd=MagickFalse;
               if (length > 5)
                 {
                   mng_info->mng_global_bkgd.red
-                    =ScaleShortToQuantum(((p[0] << 8) | p[1]));
+                    =ScaleShortToQuantum((((magick_uint32_t) p[0] << 8) |
+                                          (magick_uint32_t) p[1]));
                   mng_info->mng_global_bkgd.green
-                    =ScaleShortToQuantum(((p[2] << 8) | p[3]));
+                    =ScaleShortToQuantum((((magick_uint32_t) p[2] << 8) |
+                                          (magick_uint32_t) p[3]));
                   mng_info->mng_global_bkgd.blue
-                    =ScaleShortToQuantum(((p[4] << 8) | p[5]));
-                  mng_info->have_global_bkgd=True;
+                    =ScaleShortToQuantum((((magick_uint32_t) p[4] << 8) |
+                                          (magick_uint32_t) p[5]));
+                  mng_info->have_global_bkgd=MagickTrue;
                 }
               MagickFreeMemory(chunk);
               continue;
@@ -4101,16 +4428,20 @@ static Image *ReadMNGImage(const ImageIn
               if (mandatory_back && length > 5)
                 {
                   mng_background_color.red=
-                    ScaleShortToQuantum(((p[0] << 8) | p[1]));
+                    ScaleShortToQuantum((((magick_uint32_t) p[0] << 8) |
+                                         (magick_uint32_t) p[1]));
                   mng_background_color.green=
-                    ScaleShortToQuantum(((p[2] << 8) | p[3]));
+                    ScaleShortToQuantum((((magick_uint32_t) p[2] << 8) |
+                                         (magick_uint32_t) p[3]));
                   mng_background_color.blue=
-                    ScaleShortToQuantum(((p[4] << 8) | p[5]));
+                    ScaleShortToQuantum((((magick_uint32_t) p[4] << 8) |
+                                         (magick_uint32_t) p[5]));
                   mng_background_color.opacity=OpaqueOpacity;
                 }
 #ifdef MNG_OBJECT_BUFFERS
               if (length > 8)
-                mng_background_object=(p[7] << 8) | p[8];
+                mng_background_object=((magick_uint32_t) p[7] << 8) |
+                  (magick_uint32_t) p[8];
 #endif
 #endif
               MagickFreeMemory(chunk);
@@ -4118,9 +4449,6 @@ static Image *ReadMNGImage(const ImageIn
             }
           if (!memcmp(type,mng_PLTE,4))
             {
-              register long
-                i;
-
               /*
                 Read global PLTE.
               */
@@ -4154,9 +4482,6 @@ static Image *ReadMNGImage(const ImageIn
             }
           if (!memcmp(type,mng_tRNS,4))
             {
-              register long
-                i;
-
               /* read global tRNS */
 
               if (length < 257)
@@ -4180,10 +4505,10 @@ static Image *ReadMNGImage(const ImageIn
 
                   igamma=mng_get_long(p);
                   mng_info->global_gamma=((float) igamma)*0.00001;
-                  mng_info->have_global_gama=True;
+                  mng_info->have_global_gama=MagickTrue;
                 }
               else
-                mng_info->have_global_gama=False;
+                mng_info->have_global_gama=MagickFalse;
               MagickFreeMemory(chunk);
               continue;
             }
@@ -4195,9 +4520,12 @@ static Image *ReadMNGImage(const ImageIn
               */
               if (length == 32)
                 {
-                  mng_info->global_chrm.white_point.x=0.00001*mng_get_long(p);
-                  mng_info->global_chrm.white_point.y=0.00001*mng_get_long(&p[4]);
-                  mng_info->global_chrm.red_primary.x=0.00001*mng_get_long(&p[8]);
+                  mng_info->global_chrm.white_point.x=0.00001*
+                    mng_get_long(p);
+                  mng_info->global_chrm.white_point.y=0.00001*
+                    mng_get_long(&p[4]);
+                  mng_info->global_chrm.red_primary.x=0.00001*
+                    mng_get_long(&p[8]);
                   mng_info->global_chrm.red_primary.y=0.00001*
                     mng_get_long(&p[12]);
                   mng_info->global_chrm.green_primary.x=0.00001*
@@ -4208,10 +4536,10 @@ static Image *ReadMNGImage(const ImageIn
                     mng_get_long(&p[24]);
                   mng_info->global_chrm.blue_primary.y=0.00001*
                     mng_get_long(&p[28]);
-                  mng_info->have_global_chrm=True;
+                  mng_info->have_global_chrm=MagickTrue;
                 }
               else
-                mng_info->have_global_chrm=False;
+                mng_info->have_global_chrm=MagickFalse;
               MagickFreeMemory(chunk);
               continue;
             }
@@ -4223,10 +4551,10 @@ static Image *ReadMNGImage(const ImageIn
               if (length)
                 {
                   mng_info->global_srgb_intent=(RenderingIntent) (p[0]+1);
-                  mng_info->have_global_srgb=True;
+                  mng_info->have_global_srgb=MagickTrue;
                 }
               else
-                mng_info->have_global_srgb=False;
+                mng_info->have_global_srgb=MagickFalse;
               MagickFreeMemory(chunk);
               continue;
             }
@@ -4237,17 +4565,18 @@ static Image *ReadMNGImage(const ImageIn
               /*
                 Read global iCCP.
               */
-              if (length)
-                MagickFreeMemory(chunk);
+              MagickFreeMemory(chunk);
               continue;
             }
           if (!memcmp(type,mng_FRAM,4))
             {
               if (mng_type == 3)
                 (void) ThrowException2(&image->exception,CoderError,
-                                       "FRAM chunk found in MNG-VLC datastream",
+                                       "FRAM chunk found in MNG-VLC"
+                                       " datastream",
                                        (char *) NULL);
-              if ((mng_info->framing_mode == 2) || (mng_info->framing_mode == 4))
+              if ((mng_info->framing_mode == 2) ||
+                  (mng_info->framing_mode == 4))
                 image->delay=frame_delay;
               frame_delay=default_frame_delay;
               frame_timeout=default_frame_timeout;
@@ -4257,7 +4586,8 @@ static Image *ReadMNGImage(const ImageIn
                   mng_info->framing_mode=p[0];
               if (logging)
                 (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                      "    Framing_mode=%d",mng_info->framing_mode);
+                                      "    Framing_mode=%d",
+                                      mng_info->framing_mode);
               if (length > 6)
                 {
                   /*
@@ -4278,7 +4608,7 @@ static Image *ReadMNGImage(const ImageIn
                       change_timeout=(*p++);
                       change_clipping=(*p++);
                       p++; /* change_sync */
-                      if (change_delay)
+                      if (change_delay && (p-chunk) < (ssize_t) (length-4))
                         {
                           frame_delay=(100*(mng_get_long(p))/
                                        mng_info->ticks_per_second);
@@ -4290,11 +4620,11 @@ static Image *ReadMNGImage(const ImageIn
                                                   "    Framing_delay=%ld",
                                                   frame_delay);
                         }
-                      if (change_timeout)
+                      if (change_timeout && (p-chunk) < (ssize_t) (length-4))
                         {
                           frame_timeout=
                             (100*(mng_get_long(p))/mng_info->ticks_per_second);
-                          if (change_delay == 2)
+                          if (change_timeout == 2)
                             default_frame_timeout=frame_timeout;
                           p+=4;
                           if (logging)
@@ -4302,14 +4632,15 @@ static Image *ReadMNGImage(const ImageIn
                                                   "    Framing_timeout=%ld",
                                                   frame_timeout);
                         }
-                      if (change_clipping)
+                      if (change_clipping && (p-chunk) < (ssize_t) (length-16))
                         {
                           fb=mng_read_box(previous_fb,p[0],&p[1]);
-                          p+=17;
+                          p+=16;
                           previous_fb=fb;
                           if (logging)
                             (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                                  "    Frame_clipping: L=%ld R=%ld T=%ld B=%ld",
+                                                  "    Frame_clipping:"
+                                                  " L=%ld R=%ld T=%ld B=%ld",
                                                   fb.left, fb.right,fb.top,
                                                   fb.bottom);
                           if (change_clipping == 2)
@@ -4317,17 +4648,26 @@ static Image *ReadMNGImage(const ImageIn
                         }
                     }
                 }
+#if defined(PNG_SETJMP_NOT_THREAD_SAFE)
+              /* To quiet a Coverity complaint */
+              AcquireSemaphoreInfo(&png_semaphore);
+#endif
               mng_info->clip=fb;
               mng_info->clip=mng_minimum_box(fb,mng_info->frame);
+#if defined(PNG_SETJMP_NOT_THREAD_SAFE)
+              LiberateSemaphoreInfo(&png_semaphore);
+#endif
               subframe_width=(mng_info->clip.right-mng_info->clip.left);
               subframe_height=(mng_info->clip.bottom-mng_info->clip.top);
               /*
-                Insert a background layer behind the frame if framing_mode is 4.
+                Insert a background layer behind the frame
+                if framing_mode is 4.
               */
 #ifdef MNG_INSERT_LAYERS
               if (logging)
                 (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                      "   subframe_width=%lu, subframe_height=%lu",
+                                      "   subframe_width=%lu,"
+                                      " subframe_height=%lu",
                                       subframe_width, subframe_height);
               if (insert_layers && (mng_info->framing_mode == 4) &&
                   (subframe_width) && (subframe_height))
@@ -4349,12 +4689,12 @@ static Image *ReadMNGImage(const ImageIn
                   mng_info->image=image;
                   if (term_chunk_found)
                     {
-                      image->start_loop=True;
+                      image->start_loop=MagickTrue;
                       image->iterations=mng_iterations;
-                      term_chunk_found=False;
+                      term_chunk_found=MagickFalse;
                     }
                   else
-                    image->start_loop=False;
+                    image->start_loop=MagickFalse;
                   image->columns=subframe_width;
                   image->rows=subframe_height;
                   image->page.width=subframe_width;
@@ -4362,14 +4702,17 @@ static Image *ReadMNGImage(const ImageIn
                   image->page.x=mng_info->clip.left;
                   image->page.y=mng_info->clip.top;
                   image->background_color=mng_background_color;
-                  image->matte=False;
+                  image->matte=MagickFalse;
                   image->delay=0;
                   (void) SetImage(image,OpaqueOpacity);
                   if (logging)
                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                          "  Inserted background layer, L=%ld, R=%ld, T=%ld, B=%ld",
-                                          mng_info->clip.left,mng_info->clip.right,
-                                          mng_info->clip.top,mng_info->clip.bottom);
+                                          "  Inserted background layer,"
+                                          " L=%ld, R=%ld, T=%ld, B=%ld",
+                                          mng_info->clip.left,
+                                          mng_info->clip.right,
+                                          mng_info->clip.top,
+                                          mng_info->clip.bottom);
                 }
 #endif
               MagickFreeMemory(chunk);
@@ -4384,19 +4727,26 @@ static Image *ReadMNGImage(const ImageIn
               /*
                 Read CLIP.
               */
-              first_object=(p[0] << 8) | p[1];
-              last_object=(p[2] << 8) | p[3];
-              for (i=(int) first_object; i <= (int) last_object; i++)
-                {
-                  if (i > MNG_MAX_OBJECTS)
-                      continue;
-                  if (mng_info->exists[i] && !mng_info->frozen[i])
+              if (length > 3)
+                {
+                  first_object=((magick_uint32_t) p[0] << 8) | (magick_uint32_t) p[1];
+                  last_object=((magick_uint32_t) p[2] << 8) | (magick_uint32_t) p[3];
+                  p+=4;
+
+                  for (i=(int) first_object; i <= (int) last_object; i++)
                     {
-                      MngBox
-                        box;
+                      if (i > MNG_MAX_OBJECTS)
+                        continue;
+                      if (mng_info->exists[i] && !mng_info->frozen[i])
+                        {
+                          MngBox
+                            box;
 
-                      box=mng_info->object_clip[i];
-                      mng_info->object_clip[i]=mng_read_box(box,p[4],&p[5]);
+                          box=mng_info->object_clip[i];
+                          if ((p-chunk) < (ssize_t) (length-17))
+                            mng_info->object_clip[i]=
+                                mng_read_box(box,p[0],&p[1]);
+                        }
                     }
                 }
               MagickFreeMemory(chunk);
@@ -4404,28 +4754,21 @@ static Image *ReadMNGImage(const ImageIn
             }
           if (!memcmp(type,mng_SAVE,4))
             {
-              register long
-                i;
-
               for (i=1; i < MNG_MAX_OBJECTS; i++)
                 if (mng_info->exists[i])
                   {
-                    mng_info->frozen[i]=True;
+                    mng_info->frozen[i]=MagickTrue;
 #ifdef MNG_OBJECT_BUFFERS
                     if (mng_info->ob[i] != (MngBuffer *) NULL)
-                      mng_info->ob[i]->frozen=True;
+                      mng_info->ob[i]->frozen=MagickTrue;
 #endif
                   }
-              if (length)
-                MagickFreeMemory(chunk);
+              MagickFreeMemory(chunk);
               continue;
             }
 
           if (!memcmp(type,mng_DISC,4) || !memcmp(type,mng_SEEK,4))
             {
-              register long
-                i;
-
               /*
                 Read DISC or SEEK.
               */
@@ -4441,12 +4784,11 @@ static Image *ReadMNGImage(const ImageIn
 
                   for (j=0; j < (long) length; j+=2)
                     {
-                      i=p[j] << 8 | p[j+1];
+                      i=(magick_uint32_t) p[j] << 8 | (magick_uint32_t) p[j+1];
                       MngInfoDiscardObject(mng_info,i);
                     }
                 }
-              if (length)
-                MagickFreeMemory(chunk);
+              MagickFreeMemory(chunk);
               continue;
             }
           if (!memcmp(type,mng_MOVE,4))
@@ -4458,25 +4800,32 @@ static Image *ReadMNGImage(const ImageIn
               /*
                 read MOVE
               */
-              first_object=(p[0] << 8) | p[1];
-              last_object=(p[2] << 8) | p[3];
-              for (i=(long) first_object; i <= (long) last_object; i++)
-                {
-                  if (i > MNG_MAX_OBJECTS)
-                      continue;
-                  if (mng_info->exists[i] && !mng_info->frozen[i])
+
+              if (length > 3)
+                {
+                  first_object=((magick_uint32_t) p[0] << 8) | (magick_uint32_t) p[1];
+                  last_object=((magick_uint32_t) p[2] << 8) | (magick_uint32_t) p[3];
+                  p+=4;
+
+                  for (i=(long) first_object; i <= (long) last_object; i++)
                     {
-                      MngPair
-                        new_pair;
+                      if (i > MNG_MAX_OBJECTS)
+                        continue;
+                      if (mng_info->exists[i] && !mng_info->frozen[i] &&
+                          (p-chunk) < (ssize_t) (length-8))
+                        {
+                          MngPair
+                            new_pair;
 
-                      MngPair
-                        old_pair;
+                          MngPair
+                            old_pair;
 
-                      old_pair.a=mng_info->x_off[i];
-                      old_pair.b=mng_info->y_off[i];
-                      new_pair=mng_read_pair(old_pair,(int) p[4],&p[5]);
-                      mng_info->x_off[i]=new_pair.a;
-                      mng_info->y_off[i]=new_pair.b;
+                          old_pair.a=mng_info->x_off[i];
+                          old_pair.b=mng_info->y_off[i];
+                          new_pair=mng_read_pair(old_pair,(int) p[0],&p[1]);
+                          mng_info->x_off[i]=new_pair.a;
+                          mng_info->y_off[i]=new_pair.b;
+                        }
                     }
                 }
               MagickFreeMemory(chunk);
@@ -4486,21 +4835,25 @@ static Image *ReadMNGImage(const ImageIn
           if (!memcmp(type,mng_LOOP,4))
             {
               long loop_iters=1;
-              loop_level=chunk[0];
-              loops_active++;
-              mng_info->loop_active[loop_level]=1;  /* mark loop active */
-              /*
-                Record starting point.
-              */
-              loop_iters=mng_get_long(&chunk[1]);
-              if (loop_iters == 0)
-                skipping_loop=loop_level;
-              else
+
+              if (length > 0) /* To do: check spec, if empty LOOP is allowed */
                 {
-                  mng_info->loop_jump[loop_level]=TellBlob(image);
-                  mng_info->loop_count[loop_level]=loop_iters;
+                  loop_level=chunk[0];
+                  loops_active++;
+                  mng_info->loop_active[loop_level]=1;  /* mark loop active */
+                  /*
+                    Record starting point.
+                  */
+                  loop_iters=mng_get_long(&chunk[1]);
+                  if (loop_iters == 0)
+                    skipping_loop=loop_level;
+                  else
+                    {
+                      mng_info->loop_jump[loop_level]=TellBlob(image);
+                      mng_info->loop_count[loop_level]=loop_iters;
+                    }
+                  mng_info->loop_iteration[loop_level]=0;
                 }
-              mng_info->loop_iteration[loop_level]=0;
               MagickFreeMemory(chunk);
               continue;
             }
@@ -4572,11 +4925,11 @@ static Image *ReadMNGImage(const ImageIn
                 magn_methy;
 
               if (length > 1)
-                magn_first=(p[0] << 8) | p[1];
+                magn_first=((magick_uint32_t) p[0] << 8) | (magick_uint32_t) p[1];
               else
                 magn_first=0;
               if (length > 3)
-                magn_last=(p[2] << 8) | p[3];
+                magn_last=((magick_uint32_t) p[2] << 8) | (magick_uint32_t) p[3];
               else
                 magn_last=magn_first;
 #ifndef MNG_OBJECT_BUFFERS
@@ -4584,7 +4937,8 @@ static Image *ReadMNGImage(const ImageIn
                 if (!mng_info->magn_warning)
                   {
                     (void) ThrowException2(&image->exception,CoderError,
-                                           "MAGN is not implemented yet for nonzero objects",
+                                           "MAGN is not implemented yet"
+                                           " for nonzero objects",
                                            image->filename);
                     mng_info->magn_warning++;
                   }
@@ -4595,42 +4949,42 @@ static Image *ReadMNGImage(const ImageIn
                 magn_methx=0;
 
               if (length > 6)
-                magn_mx=(p[5] << 8) | p[6];
+                magn_mx=((magick_uint32_t) p[5] << 8) | (magick_uint32_t) p[6];
               else
                 magn_mx=1;
               if (magn_mx == 0)
                 magn_mx=1;
 
               if (length > 8)
-                magn_my=(p[7] << 8) | p[8];
+                magn_my=((magick_uint32_t) p[7] << 8) | (magick_uint32_t) p[8];
               else
                 magn_my=magn_mx;
               if (magn_my == 0)
                 magn_my=1;
 
               if (length > 10)
-                magn_ml=(p[9] << 8) | p[10];
+                magn_ml=((magick_uint32_t) p[9] << 8) | (magick_uint32_t) p[10];
               else
                 magn_ml=magn_mx;
               if (magn_ml == 0)
                 magn_ml=1;
 
               if (length > 12)
-                magn_mr=(p[11] << 8) | p[12];
+                magn_mr=((magick_uint32_t) p[11] << 8) | (magick_uint32_t) p[12];
               else
                 magn_mr=magn_mx;
               if (magn_mr == 0)
                 magn_mr=1;
 
               if (length > 14)
-                magn_mt=(p[13] << 8) | p[14];
+                magn_mt=((magick_uint32_t) p[13] << 8) | (magick_uint32_t) p[14];
               else
                 magn_mt=magn_my;
               if (magn_mt == 0)
                 magn_mt=1;
 
               if (length > 16)
-                magn_mb=(p[15] << 8) | p[16];
+                magn_mb=((magick_uint32_t) p[15] << 8) | (magick_uint32_t) p[16];
               else
                 magn_mb=magn_my;
               if (magn_mb == 0)
@@ -4645,12 +4999,14 @@ static Image *ReadMNGImage(const ImageIn
                 if (!mng_info->magn_warning)
                   {
                     (void) ThrowException2(&image->exception,CoderError,
-                                           "Unknown MAGN method in MNG datastream",
+                                           "Unknown MAGN method in"
+                                           " MNG datastream",
                                            image->filename);
                     mng_info->magn_warning++;
                   }
 #ifdef MNG_OBJECT_BUFFERS
-              /* Magnify existing objects in the range magn_first to magn_last */
+              /* Magnify existing objects in the range magn_first
+                 to magn_last */
 #endif
               if (magn_first == 0 || magn_last == 0)
                 {
@@ -4684,7 +5040,7 @@ static Image *ReadMNGImage(const ImageIn
           if (!memcmp(type,mng_sBIT,4))
             {
               if (length < 4)
-                mng_info->have_global_sbit=False;
+                mng_info->have_global_sbit=MagickFalse;
               else
                 {
                   mng_info->global_sbit.gray=p[0];
@@ -4692,7 +5048,7 @@ static Image *ReadMNGImage(const ImageIn
                   mng_info->global_sbit.green=p[1];
                   mng_info->global_sbit.blue=p[2];
                   mng_info->global_sbit.alpha=p[3];
-                  mng_info->have_global_sbit=True;
+                  mng_info->have_global_sbit=MagickTrue;
                 }
             }
           if (!memcmp(type,mng_pHYs,4))
@@ -4702,10 +5058,10 @@ static Image *ReadMNGImage(const ImageIn
                   mng_info->global_x_pixels_per_unit=mng_get_long(p);
                   mng_info->global_y_pixels_per_unit=mng_get_long(&p[4]);
                   mng_info->global_phys_unit_type=p[8];
-                  mng_info->have_global_phys=True;
+                  mng_info->have_global_phys=MagickTrue;
                 }
               else
-                mng_info->have_global_phys=False;
+                mng_info->have_global_phys=MagickFalse;
             }
           if (!memcmp(type,mng_pHYg,4))
             {
